class: center, middle

# Exercise 1
  
  
### Protecting your host

---
## Excercise 1 - Let's start

- Lab environment:
  - Open your favourite browser, then
  - Go to [labs.pftutorial.net](https://labs.pftutorial.net)

- check that pf is indeed loaded and running (*hint*: [pfctl](http://man.openbsd.org/pfctl))

- Try accessing other lab hosts

---

## Exercise 1 - net config

- Configure the external interface on gateway

- _vi /etc/hostname.vio0_

```shell 
		inet 10.255.255.XX/24
		!route add 0/0 10.255.255.254
		inet6 fd18:b5d:cafe::XX/64
		!route add -inet6 2000::/3 fd18:b5d:cafe::a
		!route add -inet6 fd00::/8 fd18:b5d:cafe::a
```

- and then _vi /etc/resolv.conf_


```shell 
    nameserver 10.255.255.254
    nameserver fd18:b5d:cafe::a
```

followed by 

```shell 
    sh /etc/netstart
```


---

## Exercise 1 - on gateway

- Start with a block ruleset

```shell 
    block
    pass quick inet6 proto tcp from fd18::/16 to port ssh
		pass quick inet6 proto icmp6 from fd18::/16
```

- Allow traffic to be generated from your host, and allow ICMPv6

```shell
	pass from self
```

and then, reload _pf.conf_

```shell
   pfctl -vnf /etc/pf.conf
   pfctl -f /etc/pf.conf
```

- **NB:** Reload pf this way after every statement in the exercises

---

## Exercise 1 - Tests

- From your gateway ping a host

- First IPv6

```shell 
 # ping6 fd18:b5d:cafe::a
 PING fd18:b5d:cafe::a (fd18:b5d:cafe::a): 56 data bytes
 64 bytes from fd18:b5d:cafe::a: icmp_seq=0 hlim=64 time=0.548 ms
 64 bytes from fd18:b5d:cafe::a: icmp_seq=1 hlim=64 time=0.492 ms
 64 bytes from fd18:b5d:cafe::a: icmp_seq=2 hlim=64 time=0.494 ms

```

- Then IPv4

```shell 
 # ping stucchi.ch
 PING stucchi.ch (37.59.51.141): 56 data bytes
 64 bytes from 37.59.51.141: icmp_seq=0 ttl=56 time=6.264 ms
 64 bytes from 37.59.51.141: icmp_seq=1 ttl=56 time=6.273 ms
 64 bytes from 37.59.51.141: icmp_seq=2 ttl=56 time=6.117 ms
```

---

## Exercise 1 - Wrap up

- Does ping work?

- Do other commands work?
  - working from total block, proceed to make restricted workstation
    - name resolution
    - _http_ and _https_

- Access public web sites, other Internet resources.

- What would it take to access the other lab hosts?

---

class: center, middle


# Questions ?
  
???

Let's ask if there are any questions before continuing.  Make sure we have everyone onboard.

---
