
class: center, middle

# Exercise 2
  
  
### Protecting your network

---

## Exercise 2 - Goals

- Your network grows, you become a gateway

- Extend the configuration to enable the network to access the internet

---
background-image: url(images/exercise2.png)

## Exercise 2 - Your network


---

## Exercise 2

- Turn on ip forwarding (sysctl)

```shell 
    # sysctl net.inet.ip.forwarding=1 
    # sysctl net.inet6.ip6.forwarding=1 
```

- Set up NAT

```shell
	match out on egress inet nat-to (egress)
```

Also, pass traffic from that local net

---
## Exercise 2 - preparation

- Configure the hosts with the following IPv6 addresses
  - *Gateway (vio1):* fd18:b5d:XX::a/64
  - *Host1:* fd18:b5d:XX::80/64
  - *Host2:* fd18:b5d:XX::25/64
<br/ > <br/>

- On Host1 and Host2, set fd18:b5d:XX::a as the default IPv6 gateway

- and also the following IPv4 addresses
  - *Gateway (vio1):* 192.168.XX.1/24
	- *Host1:* 192.168.XX.2/24
	- *Host2:* 192.168.XX.3/24

- On Host1 and Host2 set 192.168.XX.1 as the default IPv4 gateway

---

## Exercise 2 - check your results

- From client 1, ping a host on the internet

- First IPv6

```shell 
 # ping6 stucchi.ch
 PING stucchi.ch (2001:41d0:8:6ed8::80): 56 data bytes
 64 bytes from 2001:41d0:8:6ed8::80: icmp_seq=1 hlim=56 time=7.414 ms
 64 bytes from 2001:41d0:8:6ed8::80: icmp_seq=2 hlim=56 time=6.333 ms
 64 bytes from 2001:41d0:8:6ed8::80: icmp_seq=3 hlim=56 time=6.441 ms
```

- Then IPv4

```shell 
 # ping stucchi.ch
 PING stucchi.ch (37.59.51.141): 56 data bytes
 64 bytes from 37.59.51.141: icmp_seq=0 ttl=56 time=6.264 ms
 64 bytes from 37.59.51.141: icmp_seq=1 ttl=56 time=6.273 ms
 64 bytes from 37.59.51.141: icmp_seq=2 ttl=56 time=6.117 ms
```

---
# Exercise 2b: FTP

Try fetching *ftp://ftp.ripe.net/pub/stats/ripencc/delegated-ripencc-extended-latest*

```shell
 # wget ftp://ftp.ripe.net/pub/stats/ripencc/delegated-ripencc-extended-latest
```

Check your result

If it didn't work, configure FTP-proxy and try again.


---
