class: center, middle
# Exercise 3

  
### Offering services

---

## Excercise 3 - Goals

- You're now offering services
<br><br><br>
- **Host 1** will provide **http** service
<br><br><br>
- **Host 2** will provide **smtp** service
<br><br><br>
- We need to setup:
  - The services
  - Redirects
  - Firewall rules

---
background-image: url(images/exercise3.png)
class: right
## Exercise 3 - Network

???

This is not exactly the network we have, but could be thought as such.

Host1 and Host2 are in what could be considered our DMZ.


---
## Exercise 3 - on Host1

- We need to configure and start httpd

```shell
 # cp /etc/examples/httpd.conf /etc/httpd.conf

 < comment out the HTTPS part >

 # rcctl enable httpd
 # rcctl start httpd
 httpd(ok)
```

---
## Exercise 3 - on Host2

- Change the config to listen on all interfaces:
  - Change the appropriate line in
  
### /etc/mail/smtpd.conf

```shell
  listen on all
```
<br><br>
- Then start the daemon

```shell
 # rcctl enable smtpd
 # rcctl start smtpd
 smtpd(ok)
```
- (It might take a while)

---
## Exercise 3 - on gateway

### /etc/pf.conf

```shell
webserver_v4 = "$IP_addr_of_host1"
webserver_v6 = "fd18:b5d:XX::80"
webports = "{ http, https }"
emailserver_v4 = "$IP_addr_of_host2"
emailserver_v6 = "fd18:b5d:XX::25"
email = "{ smtp, pop3, imap, imap3, imaps, pop3s }"

match in on egress inet proto tcp to egress port $webports rdr-to $webserver_v4
match in on egress inet proto tcp to egress port $email rdr-to $emailserver_v4

pass inet proto tcp to $webserver_v4 port $webports
pass inet proto tcp to $emailserver_v4 port $email
pass log inet proto tcp from $emailserver_v4 to port smtp

pass inet6 proto tcp to $webserver_v6 port $webports
pass inet6 proto tcp to $emailserver_v6 port $email
pass log inet6 proto tcp from $emailserver_v6 to port smtp
```

- **NB:** No redirects are needed for IPv6

---
## Exercise 3 - checks

- Try connecting to the HTTP and SMTP port of your friends/neighbours:
<br><br>
- From Gateway:

```shell
    telnet -6 fd18:b5d:XX::80 80
    telnet -4 10.255.255.XX 80

```
<br><br>
- and

```shell
    telnet -6 fd18:b5d:XX::25 25
    telnet -4 10.255.255.XX 25

```

---

## Tips

- Decide your network topology
  - DMZ (?)
  - Multi-customer (?)
  - Multi-customer, Multi-DMZ(?)

- Segment off your subnets
  - IPv4 (Do you NAT)?
  - IPv6
  - Do you do NAT64?

- Per subnet (customer)
  - Which services do you expose?
  - Write the rules
  - pamper^H^H^H^H^Hproxying

---

