
class: center, middle

# Exercise 5

  
### NAT64

---

##  NAT64

- Single-stack clients will only have IPv6
<br><br>

- Translator box will strip all headers and replace them with IPv4
<br><br>
- Requires some DNS “magic”
  - Capture responses and replace A with AAAA
  - Response is crafted based on target IPv4 address

<br><br>
- Usually implies address sharing on IPv4


---
background-image: url(images/nat64.png)


---

## 464-XLAT

- Extension to NAT64 to access IPv4-only applications (like Skype or Whatsapp)
<br><br><br>

- Handset pretends there is an IPv4 address (CLAT) and sends IPv4 packets in UDP over IPv6

---
background-image: url(images/464-xlat.png)


---

## Exercise 5 - Goals

- Define the translating prefix
  - 64:ff9b::/96 is reserved by IETF

- Add NAT64 configuration to PF

- Remove IPv4 from the internal network

- Configure DNS64 on unbound

---

## Exercise 5

- _pf.conf_

```shell
pass in quick on $int_if inet6 from any to 64:ff9b::/96 \
   af-to inet from (egress:0) keep state
```

- _unbound.conf_

```shell
module-config: "dns64 validator iterator"

dns64-prefix: 64:FF9B::/96

```

and it's done!

---

