class: center, middle

# Tips
  
  
### Section 5

---
# Choosing your ISP, a quick guide

- Are they national or regional IX members?
<br><br>
- Do they have geographical redundancy ?
  - or do you need to arrange that for yourself ?
<br><br>
- Do they actually understand your questions about peering, routing, multiple paths?
  - (avoid consumer oriented SOHO-only shops)
<br><br>
- Do they _suck_?

---
## Getting transit

- Find well peered transit providers
  - Can improve quality and shorten AS paths
  - No capacity problems
<br><br><br>
- Find your top traffic destinations:
  - Can improve quality
  - Peer with them or find closer upstream
  - Traffic profile from flow collectors can be useful

---

## Common mistakes

- No diversity
  - All reached over same cable
  - All connect to the same transit
  - All have poor onward transit and peering arrangements 
<br><br><br>
- Signing up with too many transit providers
  - Lots of small circuits
  - These cost more per Mbps than larger ones

---
##   Basic OpenBGPd configuration, operation and interaction with PF
  
  - **B**order **G**ateway **P**rotocol
    - Manage and exchange route information with BGP peers

  - Once you have the ASn registered, do the basic config. 
<!--
- You will be in [phessler's session](https://www.bsdcan.org/2019/schedule/events/1087.en.html), right?
-->
  - In your *pf.conf*:
    - enable BGP to pass between your routers and your peers' -- **TCP and UDP 179**

  - **Neat trick**: Define tables in your [pf.conf](http://man.openbsd.org/pf.conf)
    - bgpd maintains them via **pftable** attributes on [bgpd.conf](http://man.openbsd.org/bgpd.conf) objects

---
## Use cases for OSPF, BGP or ECMP

- **OSPF:** **O**pen **S**hortest **P**ath **F**irst 
  - Each router maintains link state information for links and networks within your AS
  - Calculates routing cost
  - Use [ospf6d](http://man.openbsd.org/ospf6d) for IPv6
  - Use [ospfd](http://man.openbsd.org/ospfd) for IPv4
  - Need to *pass proto ospf* between routers.

- **BGP:** announces and receives routes
  - Use [bgpd](http://man.openbsd.org/bgpd)
  - need to *pass proto tcp port 179* between routers

- **ECMP:** **E**qual **C**ost **M**ulti-**P**ath
  - target reachable via more than one route
  - load distribution or redundancy over multiple links
  - **Tip** Use [ifstated](http://man.openbsd.org/ifstated) to handle link downtime.

---
## BCP38, MANRS and Internet peering

- "[**BCP38**](https://tools.ietf.org/html/bcp38)"
  - Discussed also in another effort
  
- **M**utually **A**greed **N**orms for **R**outing **S**ecurity (MANRS)

- Define four concrete actions network operators should implement
  - Coordination
    - Keep your contacts updated
  - Validation
    - Route objects, RPKI, BGPSec
  - Anti-spoofing
    - uRPF
  - Filtering

- Build a visible community of security-minded operators

- Valuable resource: [The Routing Manifesto](https://www.routingmanifesto.org/)

---
##    Introducing VXLAN in your network

[vxlan](http://man.openbsd.org/vxlan) - the **V**irtual e**X**tensible **L**ocal **A**rea **N**etwork tunnel interface
<br><br>
- Pushes layer 2 network (Ethernet frames) over layer 3 (IP) tunnels
  - 24-bit *vnetid* (vs max 4k VLANs)
<br><br>
- Has *no* built in security
- Intended for '*trusted*' (Datacenter, inter-hypervisor) environments
  - Otherwise, consider transport over IPSEC.
<br><br>
- Default transport over **UDP 4789** (aka **vxlan**)
 - make sure that traffic passes between endpoints

---
#    Introducing VXLAN in your network

```shell
 # ifconfig vxlan0 tunnel 192.168.100.101 192.168.200.201 vnetid 17
 # ifconfig vxlan0 10.11.12.100/24

```
<br><br>
```shell
 # ifconfig vxlan0 tunnel 192.168.200.201 192.168.100.101  vnetid 17
 # ifconfig vxlan0 10.11.12.101/24

```
<br><br>
```shell
table &lt;vxendpoints&gt; { 192.168.200.201 192.168.200.204 }
pass from &lt;vxendpoints&gt; to port vxlan
```
<br><br>
Buy [Reyk](http://www.bsdcan.org/2017/schedule/speakers/227.en.html) a beer.

 
---
## Readable and maintainable toolsets

- **Macros**
  - descriptive names, keep uniform
- **Tables** 
  - descriptive names
  - consider daemon/scripting interface
- **Interface groups**
  - you know egress already
  - make your own and filter on them
- **Anchors**
  - group rules by common criteria
  - tagging 
  - interface or group
- Service names vs port numbers

- **Comments** - yes, you **will** forget why this was a good idea

---
## Now let's add wireless

- Wireless used to be hard, (WPA in particular), now it's 'just another interface'
<br><br>
- 802.11* support in OpenBSD has a,b,g,n but no ac yet
<br><br>
- Not all drivers support hostap
  - check man pages before buying kit for access point use
<br><br>
- Optionally setup with commercial APs for radio part
  - do DHCP, filtering, authentication and so forth from OpenBSD

---
class: center, middle


# Questions ?
  
???

Let's ask if there are any questions before continuing.  Make sure we have everyone onboard.

---

